#[doc = "Register `PWR_INTR` reader"]
pub struct R(crate::R<PWR_INTR_SPEC>);
impl core::ops::Deref for R {
    type Target = crate::R<PWR_INTR_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::convert::From<crate::R<PWR_INTR_SPEC>> for R {
    fn from(reader: crate::R<PWR_INTR_SPEC>) -> Self {
        R(reader)
    }
}
#[doc = "Register `PWR_INTR` writer"]
pub struct W(crate::W<PWR_INTR_SPEC>);
impl core::ops::Deref for W {
    type Target = crate::W<PWR_INTR_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::ops::DerefMut for W {
    #[inline(always)]
    fn deref_mut(&mut self) -> &mut Self::Target {
        &mut self.0
    }
}
impl core::convert::From<crate::W<PWR_INTR_SPEC>> for W {
    fn from(writer: crate::W<PWR_INTR_SPEC>) -> Self {
        W(writer)
    }
}
#[doc = "Field `LVD` writer - Indicates an Low Voltage Detect interrupt"]
pub struct LVD_W<'a> {
    w: &'a mut W,
}
impl<'a> LVD_W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 1)) | ((value as u32 & 0x01) << 1);
        self.w
    }
}
impl W {
    #[doc = "Bit 1 - Indicates an Low Voltage Detect interrupt"]
    #[inline(always)]
    pub fn lvd(&mut self) -> LVD_W {
        LVD_W { w: self }
    }
    #[doc = "Writes raw bits to the register."]
    pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
        self.0.bits(bits);
        self
    }
}
#[doc = "Power System Interrupt Register\n\nThis register you can [`read`](crate::generic::Reg::read), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [pwr_intr](index.html) module"]
pub struct PWR_INTR_SPEC;
impl crate::RegisterSpec for PWR_INTR_SPEC {
    type Ux = u32;
}
#[doc = "`read()` method returns [pwr_intr::R](R) reader structure"]
impl crate::Readable for PWR_INTR_SPEC {
    type Reader = R;
}
#[doc = "`write(|w| ..)` method takes [pwr_intr::W](W) writer structure"]
impl crate::Writable for PWR_INTR_SPEC {
    type Writer = W;
}
#[doc = "`reset()` method sets PWR_INTR to value 0"]
impl crate::Resettable for PWR_INTR_SPEC {
    #[inline(always)]
    fn reset_value() -> Self::Ux {
        0
    }
}
